select 
	an.numero as numero_matriz
	, an.regassocraca as registro 
	, (select count(l.cdlactacao) from lactacao l where l.cdanimal = lac.cdanimal and l.dtinicio <= lac.dtinicio) ordem_lactacao 
	, an.dtnascimento as data_nascimento 
	, (select pai.numero from animal pai where pai.cdanimal = an.cdpai) as numero_pai 
	, (select pai.nomecompleto from animal pai where pai.cdanimal = an.cdpai) as nome_completo_pai
	, (select pai.regassocraca from animal pai where pai.cdanimal = an.cdpai) as registro_pai 
	, (select avoMat.numero from animal avoMat where avoMat.cdanimal = (select mae.cdpai from animal mae where mae.cdanimal = an.cdmae)) as numero_avo_materno 
	, (select avoMat.nomecompleto from animal avoMat where avoMat.cdanimal = (select mae.cdpai from animal mae where mae.cdanimal = an.cdmae)) as nome_completo_avo_materno 
	, (select avoMat.regassocraca from animal avoMat where avoMat.cdanimal = (select mae.cdpai from animal mae where mae.cdanimal = an.cdmae)) as registro_avo_materno 
	, (coalesce(lac.dtfim,current_date)-lac.dtinicio) as duracao_lactacao_ou_del_atual 
	, prodTotal.producaototal as producao_total 
	, prod305.producao305 as producao_305
	, (ultTentSeg.data - lac.dtinicio) as dias_em_aberto 
	, (case sp.creprodutiva
	   when '1' then 'Inseminada' 
	   when '2' then 'Implantada' 
	   when '3' then 'Gestante' 
	   when '4' then 'Vazia' 
	   else null end) as situacao_reprodutiva
	, ((priPar.data-an.dtnascimento)/30.5) as idade_prim_parto_meses
	, (select count(*) from reproducao ten where ten.cdanimal = lac.cdanimal and ten.cdtiporeproducao = any (select cdtiporeproducao from reproducao where cdtiporeproducao < 4) and ten.data between lac.dtinicio and coalesce(l2.dtinicio,current_date)) as numero_servicos
	, (case ultTent.cdtiporeproducao
	   when '1' then 'Inseminao'
	   when '2' then 'Cobertura'
	   when '3' then 'Transferncia de Embrio'
	   else null end) as tipo_ult_servico 
	, (select touro.numero from animal touro where touro.cdanimal = ultTent.cdreprodutor) as numero_touro_ult_prenhez
	, (select touro.nomecompleto from animal touro where touro.cdanimal = ultTent.cdreprodutor) as nome_completo_touro_ult_prenhez 
	, (select touro.regassocraca from animal touro where touro.cdanimal = ultTent.cdreprodutor) as registro_touro_ult_prenhez 
	, ultPar.data as data_ocorrencia_parto  
	, (select tp.descricao from tipoparto tp where tp.cdtipoparto = ultPar.cdtipoparto) as tipo_parto 
	, (select dtpartoprovavel from reproducao dg1 where dg1.cdreproducao = (select first 1 d.cdreproducao from reproducao d where d.cdanimal = lac.cdanimal and d.data < ultPar.data and d.cdtiporeproducao = 4 order by d.data desc)) as data_provavel_parto_ocorrido 
	, (select dtpartoprovavel from reproducao dg2 where dg2.cdreproducao = (select first 1 d.cdreproducao from reproducao d where d.cdanimal = lac.cdanimal and d.data < l2.dtinicio and d.cdtiporeproducao = 4 order by d.data desc)) as data_prevista_prox_parto
	, (select tb.descricao from tipobaixa tb where tb.cdtipobaixa = an.cdtipobaixa) as tipo_baixa 
	, (select mb.descricao from motivobaixa mb where mb.cdmotivobaixa = an.cdmotivobaixa) as motivo_baixa
	, an.dtbaixa as data_baixa
	, (select numero from animal tou1 where tou1.cdanimal = priTent.cdreprodutor) as numero_touro_prim_serv_lactacao 
	, (select nomecompleto from animal tou1 where tou1.cdanimal = priTent.cdreprodutor) as nome_completo_touro_prim_serv_lactacao 
	, (select regassocraca from animal tou1 where tou1.cdanimal = priTent.cdreprodutor) as registro_touro_prim_serv_lactacao 
from 
	lactacao lac
	left join animal an on an.cdanimal = lac.cdanimal
	left join reproducao priPar on priPar.cdreproducao = (select first 1 pp.cdreproducao
														  from reproducao pp 
														  where pp.cdanimal = an.cdanimal 
														 	and pp.cdtiporeproducao = 7 
														  order by pp.data asc)
	left join reproducao ultTent on ultTent.cdreproducao = (select first 1 t.cdreproducao
													  from reproducao t 
													  where t.cdanimal = priPar.cdanimal
													  	and t.cdtiporeproducao = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao < 4) 
													 	and t.data < lac.dtinicio
													  order by t.data desc)	
	left join reproducao ultPar on ultPar.cdreproducao = (select first 1 p.cdreproducao
														  from reproducao p 
														  where p.cdanimal = ultTent.cdanimal
														  	and p.cdtiporeproducao = 7
														  	and p.data = lac.dtinicio
														  order by p.data desc)
	left join lactacao l0 on l0.cdlactacao = (select first 1 cdlactacao 
											  from lactacao l
											  where l.cdanimal = lac.cdanimal 
											  	and l.dtinicio < lac.dtinicio 
											  order by l.dtinicio desc)	
	left join lactacao l2 on l2.cdlactacao = (select first 1 cdlactacao 
											  from lactacao l
											  where l.cdanimal = lac.cdanimal 
											  	and l.dtinicio > lac.dtinicio 
											  order by l.dtinicio asc)										  
	left join reproducao priTent on priTent.cdreproducao = (select first 1 t.cdreproducao 
															from reproducao t 
															where t.cdanimal = lac.cdanimal
																and t.cdtiporeproducao = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao < 4)
													 			and t.data between coalesce(l0.dtinicio, '1900-01-01') and lac.dtinicio 																													 			
													 		order by t.data asc) 
	left join reproducao ultTentSeg on ultTentSeg.cdreproducao = (select first 1 t.cdreproducao
													  from reproducao t 
													  where t.cdanimal = lac.cdanimal
													  	and t.cdtiporeproducao = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao < 4) 
													 	and t.data between lac.dtinicio and coalesce(l2.dtinicio,current_date)
													  order by t.data desc)
	left join sp_calculaproducaototal(lac.cdlactacao,coalesce(lac.dtfim,current_date)) prodTotal on 1 = 1
	left join sp_producao305(lac.cdlactacao) prod305 on 1 = 1
	left join sp_categoriaanimal(current_date, 'cdanimal = ' || lac.cdanimal) sp on 1 = 1 
where 
	an.tipoanimal = 'A'
		and an.animalrebanho = '1'
                --- ALTERE AQUI A DATA DE INCIO DAS LACTAES. MANTENHA O FORMATO 'AAAA-MM-DD' ---
		and lac.dtinicio >= '2018-01-01' 